/**
 *  Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
*/

package elements;

import frame.VisualScene;
import java.io.Serializable;
import java.util.ArrayList;
import javax.swing.JDialog;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.general.IconNodeWidget;

/**
 * Todos os elementos de QoS são um Objeto.
 * 
 * @author Luiz Gustavo Ender
 */
public abstract class Objeto extends IconNodeWidget implements Serializable {

    private String imagemNome;
    private int nivel;
    protected JDialog jDconf;
    protected Objeto parent;
    protected ArrayList<Objeto> child;

    public Objeto(Scene scene) {
        super(scene);
        //jDconf = new JDialog(jDconf, true);
        child = new ArrayList<Objeto>();
        nivel = 0;
    }

    public abstract void geraPainelConf();

    public abstract String geraComandosTC();

    public void setImagemNome(String imagemNome) {
        this.imagemNome = imagemNome;
    }

    public String getImagemNome() {
        return imagemNome;
    }

    public int getNivel() {
        return nivel;
    }

    public void setNivel(int nivel) {
        this.nivel = nivel;
    }

    public Objeto getParent() {
        return parent;
    }

    public String getParentString() {
        if (parent instanceof Qdisc) {
            Qdisc q = (Qdisc) parent;
            return q.getHandle();
        } else if (parent instanceof Classe) {
            Classe c = (Classe) parent;
            return c.getClassid();
        }
        return "";
    }

    public void setParent(String parent) {
        this.parent = ((VisualScene) getScene()).getParent(parent);
    }

    public void setParent(Objeto parent) {
        this.parent = parent;
    }

    public ArrayList<Objeto> getChild() {
        return child;
    }
}
