/**
 *  Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2013 Emerson Ribeiro de Mello e Luiz Gustavo Ender
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
*/

package frame;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author luiz
 */
public class NewProject extends javax.swing.JDialog {

    /**
     * Creates new form NewProject
     */
    private VisualInterface frame;
    private String file, iface, projeto;
    private boolean newName, newProject, testExiste;

    public NewProject(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        frame = (VisualInterface) parent;
        projeto = "NovoProjeto";
        jTFprojectname.setText(projeto);
        jTFlocal.setText(System.getProperty("user.home"));
        file = jTFlocal.getText() + "/" + jTFprojectname.getText() + ".xml";
        jTFlocalizacao.setText(file);
        newName = false;
        newProject = false;
        testExiste = true;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTFprojectname = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTFlocal = new javax.swing.JTextField();
        jTFiface = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jBlocalizar = new javax.swing.JButton();
        jBsalvar = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        jTFlocalizacao = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.title")); // NOI18N

        jLabel1.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jLabel1.text")); // NOI18N

        jTFprojectname.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jTFprojectname.text")); // NOI18N
        jTFprojectname.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTFprojectnameKeyReleased(evt);
            }
        });

        jLabel2.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jLabel2.text")); // NOI18N

        jTFlocal.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jTFlocal.text")); // NOI18N
        jTFlocal.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTFlocalKeyReleased(evt);
            }
        });

        jTFiface.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jTFiface.text")); // NOI18N

        jLabel3.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jLabel3.text")); // NOI18N

        jBlocalizar.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jBlocalizar.text")); // NOI18N
        jBlocalizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBlocalizarActionPerformed(evt);
            }
        });

        jBsalvar.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jBsalvar.text")); // NOI18N
        jBsalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBsalvarActionPerformed(evt);
            }
        });

        jLabel4.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jLabel4.text")); // NOI18N

        jTFlocalizacao.setEditable(false);
        jTFlocalizacao.setText(org.openide.util.NbBundle.getMessage(NewProject.class, "NewProject.jTFlocalizacao.text")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jBsalvar)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel3))
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFiface, javax.swing.GroupLayout.DEFAULT_SIZE, 342, Short.MAX_VALUE)
                            .addComponent(jTFprojectname)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jLabel4))
                        .addGap(1, 1, 1)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFlocalizacao)
                            .addComponent(jTFlocal))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBlocalizar)
                .addGap(12, 12, 12))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTFprojectname, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(2, 2, 2)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFiface, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addGap(1, 1, 1)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFlocal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(jBlocalizar))
                .addGap(1, 1, 1)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jTFlocalizacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jBsalvar)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBlocalizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBlocalizarActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.setDialogTitle("Salvar no diretório");
        chooser.setSelectedFile(new File(file));
        if (chooser.showOpenDialog(frame) == JFileChooser.APPROVE_OPTION) {
            if (!chooser.getSelectedFile().getName().equals(projeto)) {
                newName = true;
            }
            File f = chooser.getSelectedFile();
            if (f.exists()) {
                int yes = JOptionPane.showConfirmDialog(this, "Arquivo já existente, deseja subistituir?",
                        "Arquivo existente", JOptionPane.YES_NO_OPTION);
                if (yes != 0) {
                    return;
                }
            }
            if (f.getUsableSpace() > f.getTotalSpace()) {
                JOptionPane.showMessageDialog(this, "Não há mais espaço livre em seu HD.",
                        "Erro", JOptionPane.ERROR_MESSAGE);
                return;
            } else {
                String arq = chooser.getSelectedFile().toString();
                if ("xml".equals(arq.substring(arq.length() - 3))) {
                    file = chooser.getSelectedFile().toString();
                } else {
                    file = chooser.getSelectedFile().toString() + ".xml";
                }
                jTFlocal.setText(chooser.getSelectedFile().getPath());
                jTFlocalizacao.setText(file);
            }
            testExiste = false;
        }
    }//GEN-LAST:event_jBlocalizarActionPerformed

    private void jBsalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBsalvarActionPerformed
        File f = new File(file);
        try {
            if (testExiste) {
                if (f.exists()) {
                    int yes = JOptionPane.showConfirmDialog(this, "Arquivo já existente, deseja subistituir?",
                            "Arquivo existente", JOptionPane.YES_NO_OPTION);
                    if (yes != 0) {
                        return;
                    }
                    testExiste = false;
                }
            }

            if (f.getUsableSpace() > f.getTotalSpace()) {
                JOptionPane.showMessageDialog(this, "Não há mais espaço livre em seu HD.",
                        "Erro", JOptionPane.ERROR_MESSAGE);
                return;
            }

            if ((!"".equals(jTFprojectname.getText())) && (!"".equals(jTFiface.getText())) && (!"".equals(jTFlocal.getText()))) {
                f.createNewFile();
                f.delete();
                projeto = jTFprojectname.getText();
                iface = jTFiface.getText();
                newProject = true;
                dispose();
            } else {
                JOptionPane.showMessageDialog(this, "Favor preencher todos os campos.",
                        "Erro", JOptionPane.ERROR_MESSAGE);
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Você não tem permissão para criar o arquivo " + file,
                    "Erro", JOptionPane.ERROR_MESSAGE);
            return;
        }
    }//GEN-LAST:event_jBsalvarActionPerformed

    private void jTFprojectnameKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTFprojectnameKeyReleased
        if (!newName) {
            String local = jTFlocal.getText();
            if (local.length() > 0) {
                if (local.substring(local.length() - 1, local.length()).equals("/")) {
                    file = local + jTFprojectname.getText() + ".xml";
                } else {
                    file = local + "/" + jTFprojectname.getText() + ".xml";
                }
            } else {
                file = jTFprojectname.getText() + ".xml";
            }
            file = file.replaceAll(" ", "_");
            jTFlocalizacao.setText(file);
            testExiste = true;
        }
    }//GEN-LAST:event_jTFprojectnameKeyReleased

    private void jTFlocalKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTFlocalKeyReleased
        newName = true;
        String local = jTFlocal.getText();
        if (local.length() > 0) {
                file = local + ".xml";
        } else {
            file = jTFprojectname.getText() + ".xml";
            newName = false;
        }
        file = file.replaceAll(" ", "_");
        jTFlocalizacao.setText(file);
        testExiste = true;
    }//GEN-LAST:event_jTFlocalKeyReleased

    public String getFile() {
        return file;
    }

    public String getIface() {
        return iface;
    }

    public String getProjeto() {
        return projeto;
    }

    public boolean isNewProject() {
        return newProject;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;


                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(NewProject.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(NewProject.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(NewProject.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(NewProject.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                NewProject dialog = new NewProject(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBlocalizar;
    private javax.swing.JButton jBsalvar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField jTFiface;
    private javax.swing.JTextField jTFlocal;
    private javax.swing.JTextField jTFlocalizacao;
    private javax.swing.JTextField jTFprojectname;
    // End of variables declaration//GEN-END:variables
}
